package de.steev.Tridentwar.manager;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.scoreboard.*;

// TODO: consider building a scoreboard builder
// TODO: reworking scoreboard logic to make it possible to replace the entire scoreboard
public class ScoreBoardManager {
    private GameManager gameManager;
    private final ScoreboardManager manager;

    /**
     * Manages Scoreboards created by the plugin
     * @param gameManager the local gamemanager instance
     */
    public ScoreBoardManager(GameManager gameManager) {
        this.gameManager = gameManager;
        this.manager = Bukkit.getScoreboardManager();
    }

    /**
     * Creates and sets a scoreboard for a player
     * @param player the player
     * @param alive how many players are alive
     * @param kills how many kills the player got
     */
    public void createScoreBoard(Player player, int alive, int kills) {
        Scoreboard board = manager.getNewScoreboard();
        Objective obj = board.registerNewObjective("Tridentwar", "dummy", "SLPNetwork");
        obj.setDisplaySlot(DisplaySlot.SIDEBAR);

        obj.getScore("=-=-=-=-=-=-=-=-=-=-=").setScore(5);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.player") + " " + player.getDisplayName()).setScore(4);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.alive") + " " + alive).setScore(3);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.kills") + " " + kills).setScore(2);
        obj.getScore("").setScore(1);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.server")).setScore(0);

        player.setScoreboard(board); // **Scoreboard setzen**
    }

    /**
     * updates a players scoreboard or sets one
     * @param player the player
     * @param alive how many players are alive
     * @param kills how many kills the player got
     * TODO: add time
     */
    public void updateScoreBoard(Player player, int alive, int kills) {
        Scoreboard board = player.getScoreboard();

        // Falls der Spieler kein eigenes Scoreboard hat, erstelle eins
        if (board == null || board.getObjective(DisplaySlot.SIDEBAR) == null) {
            createScoreBoard(player, alive, kills);
            player.setScoreboard(board);
            return;
        }

        Objective obj = board.getObjective(DisplaySlot.SIDEBAR);

        if (obj == null) { // Falls das Objective aus irgendeinem Grund null ist
            obj = board.registerNewObjective("Tridentwar", "dummy", "SLPNetwork");
            obj.setDisplaySlot(DisplaySlot.SIDEBAR);
        }

        // Scores aktualisieren
        obj.getScore("=-=-=-=-=-=-=-=-=-=-=").setScore(5);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.player") + " " + player.getDisplayName()).setScore(4);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.alive") + " " + alive).setScore(3);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.kills") + " " + kills).setScore(2);
        obj.getScore("").setScore(1);
        obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.server")).setScore(0);

        player.setScoreboard(board);
    }

    /**
     * clears a player specific scoreboard
     * @param player the player
     */
    public void removeScoreBoard(Player player) {
        player.getScoreboard().clearSlot(DisplaySlot.SIDEBAR);
    }
}
