package de.steev.Tridentwar.tasks;

import de.steev.Tridentwar.manager.GameManager;
import de.steev.Tridentwar.manager.GameState;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scoreboard.DisplaySlot;
import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.Scoreboard;
import org.bukkit.scoreboard.ScoreboardManager;

public class GameStartCountdownTask extends BukkitRunnable {
    private GameManager gameManager;
    private final ScoreboardManager manager;

    public GameStartCountdownTask (GameManager gameManager) {
        this.manager = Bukkit.getScoreboardManager();
        this.gameManager = gameManager;
    }

    private int timeLeft = 10;

    @Override
    public void run() {

        Scoreboard board = manager.getNewScoreboard();

        Objective obj = board.registerNewObjective("Tridentwar", "dummy", "SLPNetwork");
        obj.setDisplaySlot(DisplaySlot.SIDEBAR);

        for (Player player : Bukkit.getOnlinePlayers()){
            obj.getScore("=-=-=-=-=-=-=-=-=-=-=").setScore(4);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.lobby.player") + " " + player.getDisplayName()).setScore(3);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.lobby.timeleft") + " " + timeLeft).setScore(2);
            obj.getScore("").setScore(1);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.server")).setScore(0);

            player.setScoreboard(board);
        }

        timeLeft--;
        if(timeLeft <= 0) {
            cancel();
            gameManager.setGameState(GameState.ACTIVE);
            return;
        }
        Bukkit.broadcastMessage(timeLeft + " seconds Until game starts!");
    }
}
